-- author: DD ModPassion
-- date: 14.04.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: farming simulator 19
GreaseAddon = {} local modName = g_currentModName function GreaseAddon.prerequisitesPresent(specializations) return true end function GreaseAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onDraw", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", GreaseAddon) SpecializationUtil.registerEventListener(vehicleType, "onPreDetach", GreaseAddon) end function GreaseAddon.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "getTurnedState", GreaseAddon.getTurnedState) end function GreaseAddon:onLoad(savegame) self.spec_greaseAddon = self[string.format("spec_%s.greaseAddon", modName)] local spec = self.spec_greaseAddon spec.attachedSPL = nil spec.attachedRoller = nil spec.greaseUse = 0.001 spec.greaseIntervalUse = 30 spec.greaseType = {} spec.greaseTypeWork = 1 spec.greaseTypeDischarge = 2 spec.greaseTypeTurned = 3 spec.greaseTypeSprayer = 4 spec.trailerFillLevel = 1 spec.greaseFillLevel = 2 spec.turnedState = false spec.showGreaseWarning = false spec.skfLincoln = {} local key = string.format("vehicle.cylindered.skfLincoln(0)") local xmlFilename = getXMLString(self.xmlFile, key.."#filename") if xmlFilename ~= nil then xmlFilename = Utils.getFilename(xmlFilename, self.baseDirectory) local skfLincolnXmlFile = loadXMLFile("skfLincoln", xmlFilename) if skfLincolnXmlFile ~= nil and skfLincolnXmlFile ~= 0 then local filename = getXMLString(skfLincolnXmlFile, "skfLincoln.filename") spec.skfLincoln.linkNode = I3DUtil.indexToObject(self.components, Utils.getNoNil(getXMLString(self.xmlFile, key.."#linkNode"), "0>"), self.i3dMappings) local i3dNode = g_i3DManager:loadSharedI3DFile(filename, self.baseDirectory, false, false, false) if i3dNode ~= 0 then spec.skfLincoln.filename = filename spec.skfLincoln.node = I3DUtil.indexToObject(i3dNode, Utils.getNoNil(getXMLString(skfLincolnXmlFile, "skfLincoln.rootNode#node"), "0")) link(spec.skfLincoln.linkNode, spec.skfLincoln.node) local volume = Utils.getNoNil(getXMLInt(skfLincolnXmlFile, "skfLincoln.volume#node"), 0) spec.skfLincoln.volume = getChildAt(spec.skfLincoln.node, volume) spec.skfLincoln.storeNode = I3DUtil.indexToObject(self.components, Utils.getNoNil(getXMLString(self.xmlFile, key.."#storeNode"), "0>"), self.i3dMappings) setVisibility(spec.skfLincoln.storeNode, false) delete(i3dNode) end delete(skfLincolnXmlFile) end end spec.skfLincoln.capacity = Utils.getNoNil(getXMLInt(self.xmlFile, key.."#capacity"), 0) local entry = {} entry.workTime = 0 local trailer = string.format("%s.trailer(0)", key) entry.fittings = Utils.getNoNil(getXMLInt(self.xmlFile, trailer.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) local entry = {} entry.workTime = 0 local dischargeable = string.format("%s.dischargeable(0)", key) entry.fittings = Utils.getNoNil(getXMLInt(self.xmlFile, dischargeable.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) local entry = {} entry.workTime = 0 local turnOnVehicle = string.format("%s.turnOnVehicle(0)", key) entry.fittings = Utils.getNoNil(getXMLInt(self.xmlFile, turnOnVehicle.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) local entry = {} entry.workTime = 0 local sprayer = string.format("%s.sprayer(0)", key) entry.fittings = Utils.getNoNil(getXMLInt(self.xmlFile, sprayer.."#greaseFittings"), 0) table.insert(spec.greaseType, entry) end function GreaseAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_greaseAddon spec.showGreaseWarning = false if self:getFillUnitExists(spec.greaseFillLevel) and not g_currentMission.missionInfo.helperBuyFuel then if  self:getFillUnitFillLevel(spec.greaseFillLevel) > 0 then if self.lastSpeedReal*1000 > 0.9 then spec.greaseType[spec.greaseTypeWork].workTime = dt/1000 + spec.greaseType[spec.greaseTypeWork].workTime end if self:getTurnedState() then spec.greaseType[spec.greaseTypeDischarge].workTime = dt/1000 + spec.greaseType[spec.greaseTypeDischarge].workTime if spec.turnedState == false then spec.greaseType[spec.greaseTypeTurned].workTime = dt/10 + spec.greaseType[spec.greaseTypeTurned].workTime spec.turnedState = true end if spec.attachedRoller ~= nil then spec.greaseType[spec.greaseTypeSprayer].workTime = dt/1000 + spec.greaseType[spec.greaseTypeSprayer].workTime end else if self:getDischargeState() ~= Dischargeable.DISCHARGE_STATE_OFF then spec.greaseType[spec.greaseTypeDischarge].workTime = dt/1000 + spec.greaseType[spec.greaseTypeDischarge].workTime end spec.turnedState = false end for _, greaseType in ipairs(spec.greaseType) do if greaseType.workTime > spec.greaseIntervalUse then local fillDelta = spec.greaseUse*greaseType.fittings self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.greaseFillLevel, -fillDelta, self:getFillUnitFillType(spec.greaseFillLevel), ToolType.UNDEFINED, unloadInfo) greaseType.workTime = 0 end end setScale(spec.skfLincoln.volume, 1, self:getFillUnitFillLevelPercentage(spec.greaseFillLevel), 1) local _, y, _ = getRotation(spec.skfLincoln.volume) setRotation(spec.skfLincoln.volume, 0, y - 0.01, 0) elseif self:getFillUnitFillLevel(spec.greaseFillLevel) <= 0 then setScale(spec.skfLincoln.volume, 1, 0.01, 1) if self:getDischargeState() ~= Dischargeable.DISCHARGE_STATE_OFF then self:setDischargeState(Dischargeable.DISCHARGE_STATE_OFF) if  self.isClient and spec.showGreaseWarning == false then spec.showGreaseWarning = true end elseif self:getTurnedState() then self:setIsTurnedOn(false) if  self.isClient and spec.showGreaseWarning == false then spec.showGreaseWarning = true end end if self:getIsAIActive() then local rootVehicle = self:getRootVehicle() rootVehicle:stopAIVehicle(AIVehicle.STOP_REASON_OUT_OF_FILL) if  self.isClient and spec.showGreaseWarning == false then spec.showGreaseWarning = true end end end end if self:getIsAIActive() then if not self:getTurnedState() then self:setIsTurnedOn(true) end if spec.attachedRoller ~= nil then if not spec.attachedRoller:getTurnedState() then self:setIsTurnedOn(true) end end end if self.isClient and isActiveForInputIgnoreSelection and spec.showGreaseWarning then g_currentMission:showBlinkingWarning(g_i18n:getText("info_firstFillTheGrease"), 2000) end end function GreaseAddon:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_greaseAddon if self:getFillUnitExists(spec.greaseFillLevel) then if self:getFillUnitFillLevel(spec.greaseFillLevel) <= 0 then g_currentMission:addExtraPrintText(g_i18n:getText("info_firstFillTheGrease")) end end end function GreaseAddon:updateDebugValues(values) local spec = self.spec_greaseAddon if self:getFillUnitExists(spec.greaseFillLevel) then table.insert(values, {name="greaseTypeWork.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeWork].workTime)}) table.insert(values, {name="greaseTypeDischarge.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeDischarge].workTime)}) table.insert(values, {name="greaseTypeTurned.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeTurned].workTime)}) table.insert(values, {name="greaseTypeSprayer.workTime", value=string.format("%.4f", spec.greaseType[spec.greaseTypeSprayer].workTime)}) table.insert(values, {name="greaseFillLevel", value=string.format("%.4f", self:getFillUnitFillLevel(spec.greaseFillLevel))}) table.insert(values, {name="greaseTypeWork.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeWork].fittings)}) table.insert(values, {name="greaseTypeDischarge.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeDischarge].fittings)}) table.insert(values, {name="greaseTypeTurned.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeTurned].fittings)}) table.insert(values, {name="greaseTypeSprayer.fittings", value=string.format("%.4f", spec.greaseType[spec.greaseTypeSprayer].fittings)}) end end function GreaseAddon:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex) local spec = self.spec_greaseAddon local nomeVeicolo = string.find(getXMLString(self.xmlFile, "vehicle.storeData.name"), "roller") if nomeVeicolo ~= nil then spec.attachedSPL = self:getAttacherVehicle() if spec.attachedSPL ~= nil then local attachedSPLisValid = 0 if spec.greaseType[spec.greaseTypeTurned].fittings ~= nil then spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeTurned].fittings = spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeTurned].fittings + spec.greaseType[spec.greaseTypeTurned].fittings attachedSPLisValid = attachedSPLisValid + 1 end if spec.greaseType[spec.greaseTypeSprayer].fittings ~= nil then spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeSprayer].fittings = spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeSprayer].fittings + spec.greaseType[spec.greaseTypeSprayer].fittings attachedSPLisValid = attachedSPLisValid + 1 end if attachedSPLisValid > 1 then spec.attachedSPL.spec_greaseAddon.attachedRoller = self else spec.attachedSPL.spec_greaseAddon.attachedRoller = nil end end end end function GreaseAddon:onPreDetach(attacherVehicle, implement) local spec = self.spec_greaseAddon if spec.attachedSPL ~= nil then spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeTurned].fittings = spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeTurned].fittings - spec.greaseType[spec.greaseTypeTurned].fittings spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeSprayer].fittings = spec.attachedSPL.spec_greaseAddon.greaseType[spec.greaseTypeSprayer].fittings - spec.greaseType[spec.greaseTypeSprayer].fittings spec.attachedSPL.spec_greaseAddon.attachedRoller = nil spec.attachedSPL = nil end end function GreaseAddon:getTurnedState() local spec = self.spec_turnOnVehicle if spec == nil then return false else return spec.isAlwaysTurnedOn or spec.isTurnedOn end end